diff --git a/volkov_rafael_lab_3/README.md b/volkov_rafael_lab_3/README.md
new file mode 100644
index 0000000..2df9a4a
--- /dev/null
+++ b/volkov_rafael_lab_3/README.md
@@ -0,0 +1,157 @@
+# Лабораторная работа №3 - REST API, Gateway и синхронный обмен между микросервисами
+
+Цель: изучение шаблона проектирования gateway, построения синхронного обмена между микросервисами и архитектурного стиля RESTful API.
+
+Задачи:
+
+Создать 2 микросервиса, реализующих CRUD на связанных сущностях.
+Реализовать механизм синхронного обмена сообщениями между микросервисами.
+Реализовать шлюз на основе прозрачного прокси-сервера nginx.
+
+# Создание микросервисов
+1-й микросервис - football-portal-application для сущности Портал футбольной тематики
+2-й микросервис - football-team-application для сущности Футбольная команда
+
+Сущность: Футбольная команда (Football Team):
+
+УИД (Уникальный идентификатор): Уникальный номер или код, идентифицирующий конкретную футбольную команду.
+Название (Name): Название футбольной команды.
+Год основания (Established Year): Год основания команды.
+Дивизион (Division): Дивизион или лига, в которой участвует команда.
+Тренер (Coach): Имя и фамилия тренера команды.
+УИД портала (portalUuid): УИД портала футбольной тематики, с которым данная команда связана. Это поле устанавливает связь "1-ко-многим" между командой и порталом.
+Информация о портале (portalInfo): Информация полученная по portalUuid и УИД портала о портале футбольной тематики. Хранит в себе информацию о Портале футбольной тематики (Name, Supported Platforms, Maximum Users).
+Сущность: Портал футбольной тематики (Football Portal):
+
+УИД (Уникальный идентификатор): Уникальный номер или код, идентифицирующий конкретный портал футбольной тематики.
+Название (Name): Название портала футбольной тематики.
+Поддерживаемые платформы (Supported Platforms): Операционные системы и устройства, на которых работает портал (Web, iOS, Android и др.).
+Максимальное количество пользователей (Maximum Users): Максимальное количество пользователей, которые могут зарегистрироваться на портале.
+Связь "1-ко-многим" между этими сущностями реализуется через поле "УИД портала" в сущности "Футбольная команда". Каждая команда связывается с конкретным порталом футбольной тематики через УИД этого портала, и это позволяет одному порталу быть связанным с несколькими футбольными командами.
+
+Пример модели "Портал футбольной тематики" для списка:
+{
+ "uuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "Name": "FootballHub",
+ "Supported Platforms": "Web, iOS, Android",
+ "Maximum Users": 100000
+}
+
+Пример модели "Портал футбольной тематики" для создания или изменения:
+{
+ "uuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "Name": "FootballHub",
+ "Supported Platforms": "Web, iOS, Android",
+ "Maximum Users": 100000
+}
+
+Пример модели "Футбольная команда" для списка:
+{
+ "uuid": "8740d660-b251-4272-8535-be7ec3748d4b",
+ "Name": "FC Red Stars",
+ "Established Year": 1990,
+ "Division": "Premier League",
+ "Coach": "John Smith",
+ "portalUuid": "8f036445-a5bd-401c-926e-840f9de795cd"
+}
+
+Пример модели "Футбольная команда" для создания или изменения:
+{
+ "Name": "FC Red Stars",
+ "Established Year": 1990,
+ "Division": "Premier League",
+ "Coach": "John Smith",
+ "portalUuid": "8f036445-a5bd-401c-926e-840f9de795cd"
+}
+
+Пример модели "Футбольная команда" для подробностей:
+{
+ "uuid": "8740d660-b251-4272-8535-be7ec3748d4b",
+ "Name": "FC Red Stars",
+ "Established Year": 1990,
+ "Division": "Premier League",
+ "Coach": "John Smith",
+ "portalUuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "portalInfo": {
+ "Name": "FootballHub",
+ "Supported Platforms": "Web, iOS, Android",
+ "Maximum Users": 100000
+ }
+}
+
+
+
+
1-й микросервис
+
+
+
+
2-й микросервис
+
+
+- контроллеры для обработка запросов, дтошки для отображения в сваггере, модели для сущностей, репозитории для отправки данных, сервисы для бизнес-логики
+
+# Докер файлы, докер компоус, nginx
+
+
+
Докер файл 1-го микросервиса
+
+
+
+
Докер файл 2-го микросервиса
+
+
+-Использования базового образа, установка рабочий директории, копирования jar файла, экспорт порта, запуск приложения при запуске контейнера
+
+
Докер компоус
+
+
+-создания общей сети для сервисов, запуск образов сервисов, проброска портов, копирования конфигурационного файла nginx и запуск этого сервиса после запуска других сервисов
+
+
nginx
+
+
+установка количества одновремменных подключений, прослушка запросов по 80 порту, серверное имя локалхост, адрес для переадресации запросов по нему, url переадрусации
+
+
Скрин созданых образов
+
+
+
+
Скрин созданых контейнеров
+
+
+
+
Swagger 1-го микросервиса
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Swagger 2-го микросервиса
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# Видео
+
+Видео с разбором лабораторной работы - https://drive.google.com/file/d/1o9Ao5Q6TP-UcOb_49SbRwackclGTJOYD/view?usp=sharing
\ No newline at end of file
diff --git a/volkov_rafael_lab_3/football-portal-application/.gitignore b/volkov_rafael_lab_3/football-portal-application/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/volkov_rafael_lab_3/football-portal-application/mvnw b/volkov_rafael_lab_3/football-portal-application/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/volkov_rafael_lab_3/football-portal-application/mvnw.cmd b/volkov_rafael_lab_3/football-portal-application/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/volkov_rafael_lab_3/football-portal-application/pom.xml b/volkov_rafael_lab_3/football-portal-application/pom.xml
new file mode 100644
index 0000000..0ef733a
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/pom.xml
@@ -0,0 +1,61 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.17
+
+
+ com.example
+ football-portal-application
+ 0.0.1-SNAPSHOT
+ football-portal-application
+ Demo project for Spring Boot
+
+ 17
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+ org.springdoc
+ springdoc-openapi-ui
+ 1.7.0
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/Dockerfile b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/Dockerfile
new file mode 100644
index 0000000..d288739
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/Dockerfile
@@ -0,0 +1,14 @@
+# Используем базовый образ с Java и средой выполнения Spring Boot
+FROM openjdk:17-jdk-slim
+
+# Устанавливаем рабочий каталог внутри контейнера
+WORKDIR /app
+
+# Копируем JAR-файл приложения в контейнер (предполагается, что JAR-файл находится в каталоге target/)
+COPY target/football-portal-application-0.0.1-SNAPSHOT.jar football-portal-application.jar
+
+# Экспонируем порт, на котором будет работать приложение
+EXPOSE 8099
+
+# Запускаем приложение при запуске контейнера
+CMD ["java", "-jar", "football-portal-application.jar"]
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/FootballPortalApplication.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/FootballPortalApplication.java
new file mode 100644
index 0000000..e5c7292
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/FootballPortalApplication.java
@@ -0,0 +1,11 @@
+package com.example.footballportalapplication;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class FootballPortalApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(FootballPortalApplication.class, args);
+ }
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/controller/FootballPortalController.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/controller/FootballPortalController.java
new file mode 100644
index 0000000..be1cb4f
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/controller/FootballPortalController.java
@@ -0,0 +1,56 @@
+package com.example.footballportalapplication.controller;
+
+import com.example.footballportalapplication.model.FootballPortal;
+import com.example.footballportalapplication.dto.FootballPortalDTO;
+import com.example.footballportalapplication.service.FootballPortalService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+@RestController
+@RequestMapping("/football-portal-application")
+public class FootballPortalController {
+ private final FootballPortalService portalService;
+
+ @Autowired
+ public FootballPortalController(FootballPortalService portalService) {
+ this.portalService = portalService;
+ }
+
+ @GetMapping("/")
+ public List getAllPortals() {
+ return portalService.getAllPortals();
+ }
+
+ @GetMapping("/{uuid}")
+ public ResponseEntity getPortalByUuid(@PathVariable String uuid) {
+ return portalService.getPortalByUuid(uuid)
+ .map(portal -> ResponseEntity.ok().body(portal))
+ .orElse(ResponseEntity.notFound().build());
+ }
+
+ @PostMapping("/")
+ public ResponseEntity createPortal(@RequestBody FootballPortalDTO portalDTO) {
+ FootballPortal createdPortal = portalService.createPortal(portalDTO);
+ return ResponseEntity.status(HttpStatus.CREATED).body(createdPortal);
+ }
+
+ @PutMapping("/{uuid}")
+ public ResponseEntity updatePortal(@PathVariable String uuid, @RequestBody FootballPortalDTO portalDTO) {
+ FootballPortal updatedPortal = portalService.updatePortal(uuid, portalDTO);
+ if (updatedPortal != null) {
+ return ResponseEntity.ok().body(updatedPortal);
+ } else {
+ return ResponseEntity.notFound().build();
+ }
+ }
+
+ @DeleteMapping("/{uuid}")
+ public ResponseEntity deletePortal(@PathVariable String uuid) {
+ boolean deleted = portalService.deletePortal(uuid);
+ return deleted ? ResponseEntity.noContent().build() : ResponseEntity.notFound().build();
+ }
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/dto/FootballPortalDTO.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/dto/FootballPortalDTO.java
new file mode 100644
index 0000000..4ddd1dd
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/dto/FootballPortalDTO.java
@@ -0,0 +1,14 @@
+package com.example.footballportalapplication.dto;
+
+import lombok.AllArgsConstructor;
+import lombok.Data;
+import lombok.NoArgsConstructor;
+
+@Data
+@NoArgsConstructor
+@AllArgsConstructor
+public class FootballPortalDTO {
+ private String name;
+ private String supportedPlatforms;
+ private int maximumUsers;
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/model/FootballPortal.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/model/FootballPortal.java
new file mode 100644
index 0000000..1bd2dba
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/model/FootballPortal.java
@@ -0,0 +1,22 @@
+package com.example.footballportalapplication.model;
+
+import lombok.Data;
+
+import javax.persistence.Entity;
+import javax.persistence.GeneratedValue;
+import javax.persistence.GenerationType;
+import javax.persistence.Id;
+import javax.persistence.Table;
+
+@Entity
+@Table(name = "football_portal")
+@Data
+public class FootballPortal {
+ @Id
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+ private String uuid;
+ private String name;
+ private String supportedPlatforms;
+ private int maximumUsers;
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/repository/FootballPortalRepository.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/repository/FootballPortalRepository.java
new file mode 100644
index 0000000..b9bf471
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/repository/FootballPortalRepository.java
@@ -0,0 +1,12 @@
+package com.example.footballportalapplication.repository;
+
+import com.example.footballportalapplication.model.FootballPortal;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
+
+import java.util.Optional;
+
+@Repository
+public interface FootballPortalRepository extends JpaRepository {
+ Optional findByUuid(String uuid);
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/service/FootballPortalService.java b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/service/FootballPortalService.java
new file mode 100644
index 0000000..1ace12c
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/java/com/example/footballportalapplication/service/FootballPortalService.java
@@ -0,0 +1,70 @@
+package com.example.footballportalapplication.service;
+
+import com.example.footballportalapplication.model.FootballPortal;
+import com.example.footballportalapplication.dto.FootballPortalDTO;
+import com.example.footballportalapplication.repository.FootballPortalRepository;
+import lombok.RequiredArgsConstructor;
+import org.springframework.stereotype.Service;
+import org.springframework.transaction.annotation.Transactional;
+
+import java.util.List;
+import java.util.Optional;
+import java.util.Random;
+
+@Service
+@RequiredArgsConstructor
+public class FootballPortalService {
+ private final FootballPortalRepository portalRepository;
+
+ @Transactional
+ public List getAllPortals() {
+ return portalRepository.findAll();
+ }
+
+ @Transactional
+ public Optional getPortalByUuid(String uuid) {
+ return portalRepository.findByUuid(uuid);
+ }
+
+ @Transactional
+ public FootballPortal createPortal(FootballPortalDTO portalDTO) {
+ FootballPortal portal = new FootballPortal();
+ portal.setUuid(createUUID()); // Генерация UUID
+ portal.setName(portalDTO.getName());
+ portal.setSupportedPlatforms(portalDTO.getSupportedPlatforms());
+ portal.setMaximumUsers(portalDTO.getMaximumUsers());
+ return portalRepository.save(portal);
+ }
+
+ @Transactional
+ public FootballPortal updatePortal(String uuid, FootballPortalDTO portalDTO) {
+ Optional existingPortal = portalRepository.findByUuid(uuid);
+ if (existingPortal.isPresent()) {
+ FootballPortal portal = existingPortal.get();
+ portal.setName(portalDTO.getName());
+ portal.setSupportedPlatforms(portalDTO.getSupportedPlatforms());
+ portal.setMaximumUsers(portalDTO.getMaximumUsers());
+ return portalRepository.save(portal);
+ }
+ return null;
+ }
+
+ @Transactional
+ public boolean deletePortal(String uuid) {
+ Optional existingPortal = portalRepository.findByUuid(uuid);
+ if (existingPortal.isPresent()) {
+ portalRepository.delete(existingPortal.get());
+ return true;
+ }
+ return false;
+ }
+
+ private String createUUID() {
+ Random random = new Random();
+ long mostSigBits = random.nextLong();
+ long leastSigBits = random.nextLong();
+ return String.format("%08x-%04x-%04x-%04x-%012x",
+ mostSigBits >>> 32, (mostSigBits >>> 16) & 0xFFFF, mostSigBits & 0xFFFF,
+ (leastSigBits >>> 16) & 0xFFFF, leastSigBits & 0xFFFF);
+ }
+}
diff --git a/volkov_rafael_lab_3/football-portal-application/src/main/resources/application.properties b/volkov_rafael_lab_3/football-portal-application/src/main/resources/application.properties
new file mode 100644
index 0000000..e51fdaa
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/main/resources/application.properties
@@ -0,0 +1,8 @@
+spring.datasource.url=jdbc:h2:mem:testdb
+spring.datasource.driverClassName=org.h2.Driver
+spring.datasource.username=sa
+spring.datasource.password=password
+spring.jpa.hibernate.ddl-auto=update
+spring.h2.console.enabled=true
+
+server.port=8099
diff --git a/volkov_rafael_lab_3/football-portal-application/src/test/java/com/example/footballportalapplication/FootballPortalApplicationTests.java b/volkov_rafael_lab_3/football-portal-application/src/test/java/com/example/footballportalapplication/FootballPortalApplicationTests.java
new file mode 100644
index 0000000..29ec1e6
--- /dev/null
+++ b/volkov_rafael_lab_3/football-portal-application/src/test/java/com/example/footballportalapplication/FootballPortalApplicationTests.java
@@ -0,0 +1,13 @@
+package com.example.footballportalapplication;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class FootballPortalApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}
diff --git a/volkov_rafael_lab_3/football-team-application/.gitignore b/volkov_rafael_lab_3/football-team-application/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/volkov_rafael_lab_3/football-team-application/mvnw b/volkov_rafael_lab_3/football-team-application/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/volkov_rafael_lab_3/football-team-application/mvnw.cmd b/volkov_rafael_lab_3/football-team-application/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/volkov_rafael_lab_3/football-team-application/pom.xml b/volkov_rafael_lab_3/football-team-application/pom.xml
new file mode 100644
index 0000000..644568b
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/pom.xml
@@ -0,0 +1,60 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.17
+
+
+ com.example
+ football-team-application
+ 0.0.1-SNAPSHOT
+ football-team-application
+ Demo project for Spring Boot
+
+ 17
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springdoc
+ springdoc-openapi-ui
+ 1.7.0
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/Dockerfile b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/Dockerfile
new file mode 100644
index 0000000..cce64d5
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/Dockerfile
@@ -0,0 +1,14 @@
+# Используем базовый образ с Java и средой выполнения Spring Boot
+FROM openjdk:17-jdk-slim
+
+# Устанавливаем рабочий каталог внутри контейнера
+WORKDIR /app
+
+# Копируем JAR-файл приложения в контейнер (предполагается, что JAR-файл находится в каталоге target/)
+COPY target/football-team-application-0.0.1-SNAPSHOT.jar football-team-application.jar
+
+# Экспонируем порт, на котором будет работать приложение
+EXPOSE 8090
+
+# Запускаем приложение при запуске контейнера
+CMD ["java", "-jar", "football-team-application.jar"]
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/FootballTeamApplication.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/FootballTeamApplication.java
new file mode 100644
index 0000000..8a12261
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/FootballTeamApplication.java
@@ -0,0 +1,18 @@
+package com.example.footballteamapplication;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.context.annotation.Bean;
+import org.springframework.web.client.RestTemplate;
+
+@SpringBootApplication
+public class FootballTeamApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(FootballTeamApplication.class, args);
+ }
+
+ @Bean
+ public RestTemplate restTemplate() {
+ return new RestTemplate();
+ }
+}
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/controller/FootballTeamController.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/controller/FootballTeamController.java
new file mode 100644
index 0000000..01afbed
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/controller/FootballTeamController.java
@@ -0,0 +1,61 @@
+package com.example.footballteamapplication.controller;
+
+import com.example.footballteamapplication.dto.FootballTeamCreateUpdateDTO;
+import com.example.footballteamapplication.dto.FootballTeamDTO;
+import com.example.footballteamapplication.dto.FootballTeamDetailDTO;
+import com.example.footballteamapplication.service.FootballTeamService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+@RestController
+@RequestMapping("/football-team-application")
+public class FootballTeamController {
+ private final FootballTeamService footballTeamService;
+
+ @Autowired
+ public FootballTeamController(FootballTeamService footballTeamService) {
+ this.footballTeamService = footballTeamService;
+ }
+
+ @GetMapping("/")
+ public ResponseEntity> getFootballTeams() {
+ List footballTeams = footballTeamService.getAllFootballTeams();
+ return ResponseEntity.ok(footballTeams);
+ }
+
+ @GetMapping("/{uuid}")
+ public ResponseEntity getFootballTeam(@PathVariable String uuid) {
+ FootballTeamDetailDTO footballTeam = footballTeamService.getFootballTeamByUuid(uuid);
+ if (footballTeam != null) {
+ return ResponseEntity.ok(footballTeam);
+ }
+ return ResponseEntity.notFound().build();
+ }
+
+ @PostMapping("/")
+ public ResponseEntity createFootballTeam(@RequestBody FootballTeamCreateUpdateDTO createDTO) {
+ FootballTeamDetailDTO footballTeam = footballTeamService.createFootballTeam(createDTO);
+ return ResponseEntity.ok(footballTeam);
+ }
+
+ @PutMapping("/{uuid}")
+ public ResponseEntity updateFootballTeam(@PathVariable String uuid, @RequestBody FootballTeamCreateUpdateDTO updateDTO) {
+ FootballTeamDetailDTO footballTeam = footballTeamService.updateFootballTeam(uuid, updateDTO);
+ if (footballTeam != null) {
+ return ResponseEntity.ok(footballTeam);
+ }
+ return ResponseEntity.notFound().build();
+ }
+
+ @DeleteMapping("/{uuid}")
+ public ResponseEntity deleteFootballTeam(@PathVariable String uuid) {
+ boolean deleted = footballTeamService.deleteFootballTeam(uuid);
+ if (deleted) {
+ return ResponseEntity.ok().build();
+ }
+ return ResponseEntity.notFound().build();
+ }
+}
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/docker-compose.yml b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/docker-compose.yml
new file mode 100644
index 0000000..e99c76d
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/docker-compose.yml
@@ -0,0 +1,31 @@
+version: '3'
+services:
+ football-portal-application:
+ image: footballportalapplication_microservice_1:1.0
+ ports:
+ - "8099:8099"
+ networks:
+ - network
+
+ football-team-application:
+ image: footballteamapplication_microservice_2:1.0
+ ports:
+ - "8090:8090"
+ networks:
+ - network
+
+ nginx:
+ image: nginx:latest
+ ports:
+ - "80:80"
+ networks:
+ - network
+ volumes:
+ - ./nginx.conf:/etc/nginx/nginx.conf
+ depends_on:
+ - football-portal-application
+ - football-team-application
+
+networks:
+ network:
+ driver: bridge
\ No newline at end of file
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamCreateUpdateDTO.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamCreateUpdateDTO.java
new file mode 100644
index 0000000..250ca53
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamCreateUpdateDTO.java
@@ -0,0 +1,13 @@
+package com.example.footballteamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class FootballTeamCreateUpdateDTO {
+ private String name;
+ private int establishedYear;
+ private String division;
+ private String coach;
+ private String portalUuid;
+}
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDTO.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDTO.java
new file mode 100644
index 0000000..73ff168
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDTO.java
@@ -0,0 +1,15 @@
+package com.example.footballteamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class FootballTeamDTO {
+ private String uuid;
+ private String name;
+ private int establishedYear;
+ private String division;
+ private String coach;
+ private String portalUuid;
+}
+
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailDTO.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailDTO.java
new file mode 100644
index 0000000..a755a68
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailDTO.java
@@ -0,0 +1,15 @@
+package com.example.footballteamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class FootballTeamDetailDTO {
+ private String uuid;
+ private String name;
+ private int establishedYear;
+ private String division;
+ private String coach;
+ private String portalUuid;
+ private FootballTeamDetailInfoDTO portalInfo;
+}
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailInfoDTO.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailInfoDTO.java
new file mode 100644
index 0000000..bbf70d0
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/dto/FootballTeamDetailInfoDTO.java
@@ -0,0 +1,11 @@
+package com.example.footballteamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class FootballTeamDetailInfoDTO {
+ private String name;
+ private String supportedPlatforms;
+ private int maximumUsers;
+}
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/model/FootballTeam.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/model/FootballTeam.java
new file mode 100644
index 0000000..87ae9dc
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/model/FootballTeam.java
@@ -0,0 +1,22 @@
+package com.example.footballteamapplication.model;
+
+import lombok.Data;
+
+import javax.persistence.Entity;
+import javax.persistence.Id;
+import javax.persistence.GeneratedValue;
+import javax.persistence.GenerationType;
+
+@Entity
+@Data
+public class FootballTeam {
+ @Id
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+ private String uuid;
+ private String name;
+ private int establishedYear;
+ private String division;
+ private String coach;
+ private String portalUuid;
+}
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/nginx.conf b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/nginx.conf
new file mode 100644
index 0000000..e3db21f
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/nginx.conf
@@ -0,0 +1,19 @@
+events {
+ worker_connections 1024;
+}
+
+http {
+ server {
+ listen 80;
+ listen [::]:80;
+ server_name localhost;
+
+ location /football-portal-application/ {
+ proxy_pass http://football-portal-application:8099;
+ }
+
+ location /football-team-application/ {
+ proxy_pass http://football-team-application:8090;
+ }
+ }
+}
\ No newline at end of file
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/repository/FootballTeamRepository.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/repository/FootballTeamRepository.java
new file mode 100644
index 0000000..4b190c1
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/repository/FootballTeamRepository.java
@@ -0,0 +1,10 @@
+package com.example.footballteamapplication.repository;
+
+import com.example.footballteamapplication.model.FootballTeam;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
+
+@Repository
+public interface FootballTeamRepository extends JpaRepository {
+ FootballTeam findByUuid(String uuid);
+}
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/service/FootballTeamService.java b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/service/FootballTeamService.java
new file mode 100644
index 0000000..ac7508b
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/java/com/example/footballteamapplication/service/FootballTeamService.java
@@ -0,0 +1,117 @@
+package com.example.footballteamapplication.service;
+
+import com.example.footballteamapplication.dto.FootballTeamCreateUpdateDTO;
+import com.example.footballteamapplication.dto.FootballTeamDTO;
+import com.example.footballteamapplication.dto.FootballTeamDetailDTO;
+import com.example.footballteamapplication.dto.FootballTeamDetailInfoDTO;
+import com.example.footballteamapplication.model.FootballTeam;
+import com.example.footballteamapplication.repository.FootballTeamRepository;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.stereotype.Service;
+import org.springframework.web.client.RestTemplate;
+
+import java.util.List;
+import java.util.Random;
+import java.util.stream.Collectors;
+
+@Service
+public class FootballTeamService {
+ private final FootballTeamRepository footballTeamRepository;
+ private final RestTemplate restTemplate;
+
+ @Autowired
+ public FootballTeamService(FootballTeamRepository footballTeamRepository, RestTemplate restTemplate) {
+ this.footballTeamRepository = footballTeamRepository;
+ this.restTemplate = restTemplate;
+ }
+
+ public List getAllFootballTeams() {
+ List footballTeams = footballTeamRepository.findAll();
+ return footballTeams.stream()
+ .map(this::convertToFootballTeamDTO)
+ .collect(Collectors.toList());
+ }
+
+ public FootballTeamDetailDTO getFootballTeamByUuid(String uuid) {
+ FootballTeam footballTeam = footballTeamRepository.findByUuid(uuid);
+ if (footballTeam != null) {
+ return convertToFootballTeamDetailDTO(footballTeam);
+ }
+ return null;
+ }
+
+ public FootballTeamDetailDTO createFootballTeam(FootballTeamCreateUpdateDTO createDTO) {
+ FootballTeam footballTeam = new FootballTeam();
+ footballTeam.setUuid(createUUID());
+ updateFootballTeamFromDTO(footballTeam, createDTO);
+ footballTeam = footballTeamRepository.save(footballTeam);
+ return convertToFootballTeamDetailDTO(footballTeam);
+ }
+
+ public FootballTeamDetailDTO updateFootballTeam(String uuid, FootballTeamCreateUpdateDTO updateDTO) {
+ FootballTeam footballTeam = footballTeamRepository.findByUuid(uuid);
+ if (footballTeam != null) {
+ updateFootballTeamFromDTO(footballTeam, updateDTO);
+ footballTeam = footballTeamRepository.save(footballTeam);
+ return convertToFootballTeamDetailDTO(footballTeam);
+ }
+ return null;
+ }
+
+ public boolean deleteFootballTeam(String uuid) {
+ FootballTeam footballTeam = footballTeamRepository.findByUuid(uuid);
+ if (footballTeam != null) {
+ footballTeamRepository.delete(footballTeam);
+ return true;
+ }
+ return false;
+ }
+
+ private FootballTeamDTO convertToFootballTeamDTO(FootballTeam footballTeam) {
+ FootballTeamDTO dto = new FootballTeamDTO();
+ dto.setUuid(footballTeam.getUuid());
+ dto.setName(footballTeam.getName());
+ dto.setEstablishedYear(footballTeam.getEstablishedYear());
+ dto.setDivision(footballTeam.getDivision());
+ dto.setCoach(footballTeam.getCoach());
+ dto.setPortalUuid(footballTeam.getPortalUuid());
+ return dto;
+ }
+
+ private FootballTeamDetailDTO convertToFootballTeamDetailDTO(FootballTeam footballTeam) {
+ FootballTeamDetailDTO detailDTO = new FootballTeamDetailDTO();
+ detailDTO.setUuid(footballTeam.getUuid());
+ detailDTO.setName(footballTeam.getName());
+ detailDTO.setEstablishedYear(footballTeam.getEstablishedYear());
+ detailDTO.setDivision(footballTeam.getDivision());
+ detailDTO.setCoach(footballTeam.getCoach());
+ detailDTO.setPortalUuid(footballTeam.getPortalUuid());
+
+ FootballTeamDetailInfoDTO portalInfo = getPortalInfo(footballTeam.getPortalUuid());
+ detailDTO.setPortalInfo(portalInfo);
+
+ return detailDTO;
+ }
+
+ private void updateFootballTeamFromDTO(FootballTeam footballTeam, FootballTeamCreateUpdateDTO dto) {
+ footballTeam.setName(dto.getName());
+ footballTeam.setEstablishedYear(dto.getEstablishedYear());
+ footballTeam.setDivision(dto.getDivision());
+ footballTeam.setCoach(dto.getCoach());
+ footballTeam.setPortalUuid(dto.getPortalUuid());
+ }
+
+ private String createUUID() {
+ Random random = new Random();
+ long mostSigBits = random.nextLong();
+ long leastSigBits = random.nextLong();
+ return String.format("%08x-%04x-%04x-%04x-%012x",
+ mostSigBits >>> 32, (mostSigBits >>> 16) & 0xFFFF, mostSigBits & 0xFFFF,
+ (leastSigBits >>> 16) & 0xFFFF, leastSigBits & 0xFFFF);
+ }
+
+ private FootballTeamDetailInfoDTO getPortalInfo(String portalUuid) {
+ String portalInfoUrl = "http://nginx/football-portal-application/" + portalUuid;
+ return restTemplate.getForObject(portalInfoUrl, FootballTeamDetailInfoDTO.class);
+ }
+}
diff --git a/volkov_rafael_lab_3/football-team-application/src/main/resources/application.properties b/volkov_rafael_lab_3/football-team-application/src/main/resources/application.properties
new file mode 100644
index 0000000..b00d2a6
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/main/resources/application.properties
@@ -0,0 +1,9 @@
+spring.datasource.url=jdbc:h2:mem:testdb
+spring.datasource.driverClassName=org.h2.Driver
+spring.datasource.username=sa
+spring.datasource.password=password
+spring.jpa.hibernate.ddl-auto=update
+spring.h2.console.enabled=true
+
+server.port=8090
+
diff --git a/volkov_rafael_lab_3/football-team-application/src/test/java/com/example/footballteamapplication/FootballTeamApplicationTests.java b/volkov_rafael_lab_3/football-team-application/src/test/java/com/example/footballteamapplication/FootballTeamApplicationTests.java
new file mode 100644
index 0000000..ddaa04a
--- /dev/null
+++ b/volkov_rafael_lab_3/football-team-application/src/test/java/com/example/footballteamapplication/FootballTeamApplicationTests.java
@@ -0,0 +1,13 @@
+package com.example.footballteamapplication;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class FootballTeamApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}
diff --git a/volkov_rafael_lab_3/screens/img1.png b/volkov_rafael_lab_3/screens/img1.png
new file mode 100644
index 0000000..d9687be
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img1.png differ
diff --git a/volkov_rafael_lab_3/screens/img10.png b/volkov_rafael_lab_3/screens/img10.png
new file mode 100644
index 0000000..3956915
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img10.png differ
diff --git a/volkov_rafael_lab_3/screens/img11.png b/volkov_rafael_lab_3/screens/img11.png
new file mode 100644
index 0000000..e3469c2
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img11.png differ
diff --git a/volkov_rafael_lab_3/screens/img12.png b/volkov_rafael_lab_3/screens/img12.png
new file mode 100644
index 0000000..876b47a
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img12.png differ
diff --git a/volkov_rafael_lab_3/screens/img13.png b/volkov_rafael_lab_3/screens/img13.png
new file mode 100644
index 0000000..a354ae3
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img13.png differ
diff --git a/volkov_rafael_lab_3/screens/img14.png b/volkov_rafael_lab_3/screens/img14.png
new file mode 100644
index 0000000..58892b3
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img14.png differ
diff --git a/volkov_rafael_lab_3/screens/img15.png b/volkov_rafael_lab_3/screens/img15.png
new file mode 100644
index 0000000..ebbcc33
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img15.png differ
diff --git a/volkov_rafael_lab_3/screens/img16.png b/volkov_rafael_lab_3/screens/img16.png
new file mode 100644
index 0000000..bf556fd
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img16.png differ
diff --git a/volkov_rafael_lab_3/screens/img17.png b/volkov_rafael_lab_3/screens/img17.png
new file mode 100644
index 0000000..f876656
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img17.png differ
diff --git a/volkov_rafael_lab_3/screens/img18.png b/volkov_rafael_lab_3/screens/img18.png
new file mode 100644
index 0000000..2a52c1b
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img18.png differ
diff --git a/volkov_rafael_lab_3/screens/img2.png b/volkov_rafael_lab_3/screens/img2.png
new file mode 100644
index 0000000..6298f41
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img2.png differ
diff --git a/volkov_rafael_lab_3/screens/img3.png b/volkov_rafael_lab_3/screens/img3.png
new file mode 100644
index 0000000..ca6ff0f
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img3.png differ
diff --git a/volkov_rafael_lab_3/screens/img4.png b/volkov_rafael_lab_3/screens/img4.png
new file mode 100644
index 0000000..76a7193
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img4.png differ
diff --git a/volkov_rafael_lab_3/screens/img5.png b/volkov_rafael_lab_3/screens/img5.png
new file mode 100644
index 0000000..7a4089b
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img5.png differ
diff --git a/volkov_rafael_lab_3/screens/img6.png b/volkov_rafael_lab_3/screens/img6.png
new file mode 100644
index 0000000..3bc76d4
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img6.png differ
diff --git a/volkov_rafael_lab_3/screens/img7.png b/volkov_rafael_lab_3/screens/img7.png
new file mode 100644
index 0000000..76b63be
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img7.png differ
diff --git a/volkov_rafael_lab_3/screens/img8.png b/volkov_rafael_lab_3/screens/img8.png
new file mode 100644
index 0000000..218f80f
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img8.png differ
diff --git a/volkov_rafael_lab_3/screens/img9.png b/volkov_rafael_lab_3/screens/img9.png
new file mode 100644
index 0000000..7a2f554
Binary files /dev/null and b/volkov_rafael_lab_3/screens/img9.png differ